package expertiseFinderPrototype.expertiseExtraction;

import ExpertiseFinder.*;
import expertiseFinderPrototype.expertiseExtraction.DocumentHandlerException;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.textmining.text.extraction.WordExtractor;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.StringWriter;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.io.*;
import java.util.*;
import javax.activation.FileDataSource;
/**
 *
 * @author Audun Vennesland
 */
public class DocParser implements DocumentHandler {

//Creates a new instance of DocParser
public DocParser() {
}

public Document getDocument(InputStream is)
    throws DocumentHandlerException {

    String bodyText = null;
    try {
      bodyText = new WordExtractor().extractText(is);
    }
    catch (Exception e) {
      throw new DocumentHandlerException(
        "Cannot extract text from a Word document", e);
    }

    if ((bodyText != null) && (bodyText.trim().length() > 0)) {
      Document doc = new Document();
      doc.add(Field.UnStored("body", bodyText));
      return doc;
    }
    return null;
  }
//parses word documents in the argument folder to plain txt
public void parseToTxt(String foldername) throws Exception {
    String file = "";
    File folder = new File(foldername);
    File[] statutes = folder.listFiles();
    int noFiles = statutes.length;
    System.out.println("The folder contains: " + noFiles + " files.");

    //adds the parsed file to the correct folder
    for (int i = 0; i < noFiles; i++) {
        file = "C:\\scenario_hovedoppgave\\K2000_documents_test_txt\\" + (i+1) + ".txt";
        DocParser handler = new DocParser();
        Document doc = handler.getDocument(new FileInputStream(statutes[i]));
        System.out.println("Parsing " + statutes[i]);
        FileWriter fw = new FileWriter(file, true);
        PrintWriter pw = new PrintWriter(fw);
        pw.println(doc);
        pw.close();
    }
}

public static void main(String[] args) throws Exception {
    DocParser parser = new DocParser();
    parser.parseToTxt("C:\\scenario_hovedoppgave\\K2000_documents_test");
}

}




