package expertiseFinderPrototype.expertiseModelling;

import ExpertiseFinder.*;
import expertiseFinderPrototype.globals.GlobalValues;
import java.util.*;
import java.util.Date;
import java.sql.*;

/**
 *
 * @author Audun Vennesland
 */
public class Database {
    
    //variables used to connect to database
    private Connection connection;
    private Statement statement;
    TextProcessor tp = new TextProcessor();
    
    //constructor 
    public Database(){}
    
    //connects to database 
    public void connect(String brukernavn,String passord) throws Exception {
        Class.forName(GlobalValues.databaseDriver);
        connection = DriverManager.getConnection(GlobalValues.databaseName, GlobalValues.db_username, GlobalValues.db_password);
        statement = connection.createStatement();
    }
    //disconnects from database 
    public void disconnect() throws Exception {
        if (statement != null) statement.close();
        if (connection != null) connection.close();
        System.out.println("Database down!");
    }
    // returns employees from database and puts them in an ArrayList 
    //that's returned from the method 
    public ArrayList returnEmployees() throws Exception {
        Database db = new Database();
        ArrayList employeeList = new ArrayList();
        statement = connection.createStatement();
        //to filter queries by unit do it here...
        ResultSet res = statement.executeQuery(GlobalValues.queryWOFilter);
        while (res.next()) {
            String db_name = res.getString("name");
            String name_small = tp.turnSmall(db_name);
            String name = tp.returnCorrectNameOrder(name_small);
            String employmentDate = res.getString("employmentDate");
            String db_email = res.getString("email");
            String email = db_email.toLowerCase();
            String telephone = res.getString("telephone");
            String db_unit = res.getString("unit");
            String unit = db_unit.toLowerCase();
            String db_position = res.getString("position");
            String position = db_position.toLowerCase();
            
//Puts information in the arrayList
            Employee employee = new Employee(name, employmentDate, email, 
                    telephone, unit, position);
            employeeList.add(employee);
        }
        return employeeList;
    }
    
//returns contact information found in database
    public void getContactinfo(String expert_name) throws Exception {
        Database db = new Database();
        String ex_name = tp.returnReverseNameOrder(expert_name);
        statement = connection.createStatement();
        ResultSet res = statement.executeQuery("select * from personal where name='" + ex_name + "';");
        while (res.next()) {
            String db_name = res.getString("name");
            String name = tp.returnCorrectNameOrder(db_name);
            String db_employedDate = res.getString("employmentDate");
            String numYearsEmployed = tp.employmentTime(db_employedDate);
            String db_epost = res.getString("email");
            String epost = db_epost.toLowerCase();
            String db_telefon = res.getString("telephone");
            String telefon = db_telefon.toLowerCase();
            String db_enhet = res.getString("unit");
            String enhet = db_enhet.toLowerCase();
            String db_stilling = res.getString("position");
            String stilling = db_stilling.toLowerCase();
            
            System.out.println("Contact information: \n" +
                    "Name: " + name +
                    "\nTelephone: " + telefon +
                    "\nEmail: " + epost +
                    "\nUnit: " + enhet +
                    "\nPosition: " + stilling +
                    "\nNumber of years employed in this position: " + numYearsEmployed);
        }
    }
}
